﻿Imports System.Net.Mail

Public NotInheritable Class MailSendenKlasse
    Private Shared _Mail As New MailMessage
    Public Shared Event StartSendingMail(Text As String)
    Public Shared Event FinishedSendingMail()
    Public Shared Function TryToSendMail(MailData As MailDaten) As Boolean
        Dim Token As New Object
        RaiseEvent StartSendingMail("Email wird versendet")
        Dim MailCredentials = MailData.CreateMailCredentials()
        Dim SMTP = MailData.CreateSMTPClient
        AddHandler SMTP.SendCompleted, AddressOf sendMail_SendCompleted
        Try
            _Mail = MailData.CreateMail
            SMTP.SendAsync(_Mail, Token)
            Return True
        Catch ex As System.Net.Mail.SmtpException
            ShowMailSendingFailureTextAndDispose("Ungültige Smtp Adresse, oder kein Internet.")
        Catch ex As System.FormatException
            ShowMailSendingFailureTextAndDispose("Ungültige Absenderadresse")
        Catch ex As Exception
            ShowMailSendingFailureTextAndDispose(ex.Message)
        End Try
    End Function
    Private Shared Sub sendMail_SendCompleted(sender As Object, e As System.ComponentModel.AsyncCompletedEventArgs)
        _Mail.Dispose()
        RaiseEvent FinishedSendingMail()
    End Sub
    Private Shared Sub ShowMailSendingFailureTextAndDispose(FailureText As String)
        ShowMessageBox("Email konnte nicht gesendet werden." & Environment.NewLine & FailureText)
        _Mail.Dispose()
        RaiseEvent FinishedSendingMail()
    End Sub
End Class
