﻿Public Class UCAdressen

    Private _SaveDGVColumnWidths As Boolean
    Private Const ColumnThatContainsTelNumber = 2
    Private WithEvents sendmail As New frmEmailDaten

    Private Sub DGVAdresse_LostFocus(sender As Object, e As EventArgs) Handles DGVAdresse.LostFocus
        _SaveDGVColumnWidths = False
    End Sub
    Private Sub DGVAdresse_ColumnWidthChanged(sender As Object, e As DataGridViewColumnEventArgs) Handles DGVAdresse.ColumnWidthChanged
        If _SaveDGVColumnWidths Then My.Settings.DGVAdressenSpaltenBreite = GetDGVColumnWidthsAsSaveableString(DGVAdresse)
    End Sub
    Private Sub DGVAdresse_Click(sender As Object, e As EventArgs) Handles DGVAdresse.Click
        _SaveDGVColumnWidths = True
    End Sub
    Private Sub BTN_Click(sender As Object, e As EventArgs) Handles BTNAdresseNeu.Click, BTNAdresseKopieren.Click, BTNAdresseBearbeiten.Click,
            BTNAdresseLoeschen.Click, BTNSucheLoeschen.Click, BTNAdresseInsClipboard.Click, BTNEmailSenden.Click
        Select Case True
            Case sender Is BTNAdresseNeu : CreateNewAddress()
            Case sender Is BTNAdresseKopieren : CopyAddress()
            Case sender Is BTNAdresseBearbeiten : EditAddress()
            Case sender Is BTNAdresseLoeschen : DeleteAddress()
            Case sender Is BTNSucheLoeschen : ClearAddressSearch()
            Case sender Is BTNAdresseInsClipboard : CopyFullAddressToClipboard()
            Case sender Is BTNEmailSenden : ShowMailForm()
        End Select
        DGVAdresse.Focus()
    End Sub
    Private Sub AdresseDataGridView_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles DGVAdresse.CellDoubleClick
        Dim SelectedAddress = BSAdressen.At(Of DtsDaten.AdresseRow)
        Dim DoubleClickedColumnIndex = e.ColumnIndex
        If DoubleClickedColumnIndex = ColumnThatContainsTelNumber AndAlso SelectedAddress.Telefon1.IsNotEmpty Then
            ShowMessageBox(SelectedAddress.Telefon1)
        Else
            EditAddress()
        End If
        Return
    End Sub
    Private Sub TBAdressenDurchsuchen_TextChanged(sender As Object, e As EventArgs) Handles TBAdressenDurchsuchen.TextChanged
        Dim Searchtext As String = TBAdressenDurchsuchen.Text
        BSAdressen.Filter = $"Nachname Like '%{Searchtext}%' OR Vorname like '%{Searchtext}%' OR Notiz like '%{Searchtext}%' OR Kundennummer like '%{Searchtext}%'"
    End Sub
    Private Sub CreateNewAddress()
        BSAdressen.EditNew(Of dlgAdresseBearbeiten)
    End Sub
    Private Sub CopyAddress()
        Dim Dts = DirectCast(BSMain.DataSource, DtsDaten)
        If BSAdressen.Current Is Nothing Then Return
        Dim SelectedAddress = BSAdressen.At(Of DtsDaten.AdresseRow)
        Dim tpls As New List(Of Tuple(Of DataColumn, Object))
        With Dts.Adresse
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.UrlColumn, SelectedAddress.Url))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.NotizColumn, SelectedAddress.Notiz))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.KundennummerColumn, SelectedAddress.Kundennummer))
            BSAdressen.EditNew(Of dlgAdresseBearbeiten)(tpls)
        End With
    End Sub
    Private Sub EditAddress()
        If BSAdressen.Current Is Nothing Then Return
        BSAdressen.EditCurrent(Of dlgAdresseBearbeiten)
    End Sub
    Private Sub DeleteAddress()
        If BSAdressen.Current Is Nothing Then Return
        Dim Address = BSAdressen.At(Of DtsDaten.AdresseRow)
        If ShowMessageBoxAndAskUserYesOrNo($"Der Aressbucheintrag {Address.Nachname} {Address.Vorname} wird gelöscht.
                Sind sie sicher?") Then BSAdressen.RemoveCurrent()
    End Sub
    Private Sub ClearAddressSearch()
        TBAdressenDurchsuchen.Text = ""
        BSAdressen.RemoveFilter()
    End Sub
    Private Sub CopyFullAddressToClipboard()
        If BSAdressen.Current Is Nothing Then Return
        Dim SelectedAddress = BSAdressen.At(Of DtsDaten.AdresseRow)
        Dim Lastname = AppendNewLineIfStringIsNotEmpty(SelectedAddress.Nachname, False)
        Dim Firstname = AppendNewLineIfStringIsNotEmpty(SelectedAddress.Vorname, False)
        If Lastname.IsNotEmpty OrElse Firstname.IsNotEmpty Then Firstname &= Environment.NewLine
        If Lastname.IsNotEmpty AndAlso Firstname.IsNotEmpty Then Lastname &= " "
        Dim street = AppendNewLineIfStringIsNotEmpty(SelectedAddress.Strasse)
        Dim Place = AppendNewLineIfStringIsNotEmpty(SelectedAddress.Ort)
        Dim phone1 = AppendNewLineIfStringIsNotEmpty(SelectedAddress.Telefon1)
        Dim phone2 = AppendNewLineIfStringIsNotEmpty(SelectedAddress.Telefon2)
        Dim mail = AppendNewLineIfStringIsNotEmpty(SelectedAddress.Mail1)
        Dim CustNo = AppendNewLineIfStringIsNotEmpty(SelectedAddress.Kundennummer)
        Dim note = AppendNewLineIfStringIsNotEmpty(SelectedAddress.Notiz)

        Clipboard.SetText($"{Lastname}{Firstname}{street}{Place}{phone1}{phone2}{mail}{CustNo}{note}")
        ShowAutoClosingMessageBox("Adresse in die Zwischenablage kopiert.")
    End Sub
    Private Function AppendNewLineIfStringIsNotEmpty(Text As String, Optional NewLine As Boolean = True) As String
        If Text.IsNotEmpty Then
            If NewLine Then
                Return Text & Environment.NewLine
            Else
                Return Text
            End If
        Else
            Return ""
        End If
    End Function
    Private Sub ShowMailForm()
        sendmail = New frmEmailDaten
        With sendmail
            .BSMain.DataSource = BSMain.DataSource
            If Not BSAdressen.Current Is Nothing Then
                Dim SelectedAddress = BSAdressen.At(Of DtsDaten.AdresseRow)
                If SelectedAddress.Mail1.IsNotEmpty Then
                    .SetRecipient = SelectedAddress.Mail1
                End If
            End If
            If sendmail.ShowDialog() = DialogResult.OK Then
                ShowAutoClosingMessageBox("Email wird versendet")
            Else
                ShowAutoClosingMessageBox("Emailversand abgebrochen")
            End If
        End With
    End Sub
    Protected Overrides Function ProcessCmdKey(ByRef msg As Message, ByVal keyData As Keys) As Boolean
        Select Case keyData
            Case = Keys.Control Or Keys.N : CreateNewAddress()
            Case = Keys.Control Or Keys.K : CopyAddress()
            Case = Keys.Enter : EditAddress()
            Case = Keys.Delete : If Not TBAdressenDurchsuchen.Focused Then DeleteAddress()
            Case = Keys.Escape : ClearAddressSearch()
            Case = Keys.Control Or Keys.C : CopyFullAddressToClipboard()
            Case = Keys.Control Or Keys.E : ShowMailForm()
            Case = Keys.Back : RemoveLastCharFromSearchTextbox(TBAdressenDurchsuchen)
            Case Else
                If TBAdressenDurchsuchen.Focused Then Return MyBase.ProcessCmdKey(msg, keyData)
                Dim PressedKeyData = IsSearchableKeyPressed(keyData)
                If PressedKeyData.SearchableKeyPressed Then
                    TBAdressenDurchsuchen.Text &= PressedKeyData.PressedKey
                Else
                    Return MyBase.ProcessCmdKey(msg, keyData)
                End If
        End Select
    End Function
End Class


