﻿Public Class UCEinstellungen
    Private _SaveDGVColumnWidths As Boolean
    Private Sub DGV_LostFocus(sender As Object, e As EventArgs) Handles DGVEmailAdresse.LostFocus, DGVLieferant.LostFocus
        _SaveDGVColumnWidths = False
    End Sub
    Private Sub DGV_ColumnWidthChanged(sender As Object, e As DataGridViewColumnEventArgs) Handles DGVEmailAdresse.ColumnWidthChanged,
             DGVLieferant.ColumnWidthChanged
        Select Case True
            Case sender Is DGVEmailAdresse : If _SaveDGVColumnWidths Then My.Settings.DGVEmailAdressenSpaltenBreite = GetDGVColumnWidthsAsSaveableString(DGVEmailAdresse)
            Case sender Is DGVLieferant : If _SaveDGVColumnWidths Then My.Settings.DGVLieferantenSpaltenBreite = GetDGVColumnWidthsAsSaveableString(DGVLieferant)
        End Select
    End Sub
    Private Sub DGV_Click(sender As Object, e As EventArgs) Handles DGVEmailAdresse.Click, DGVLieferant.Click
        _SaveDGVColumnWidths = True
    End Sub
    Private Sub Button_ClickEvent(sender As Object, e As EventArgs) Handles BTNNeueEmailAdresse.Click, BTNEmailAdresseAendern.Click, BTNEmailAdresseLoeschen.Click,
            BTNNeuerLieferant.Click, BTNLieferantAendern.Click, BTNLieferantLoeschen.Click
        Select Case True
            Case sender Is BTNNeueEmailAdresse : CreateNewMailAddress()
            Case sender Is BTNEmailAdresseAendern : EditEmailAddress()
            Case sender Is BTNEmailAdresseLoeschen : DeleteEmailAddress()
            Case sender Is BTNNeuerLieferant : CreateNewSupplier()
            Case sender Is BTNLieferantAendern : EditSupplier()
            Case sender Is BTNLieferantLoeschen : DeleteSupplier()
        End Select
    End Sub
    Private Sub CreateNewMailAddress()
        BSEmailAdresse.EditNew(Of dlgEmailAdresseBearbeiten)
    End Sub
    Private Sub EditEmailAddress()
        If BSEmailAdresse.Current Is Nothing Then Return
        BSEmailAdresse.EditCurrent(Of dlgEmailAdresseBearbeiten)
    End Sub
    Private Sub DeleteEmailAddress()
        If BSEmailAdresse.Current Is Nothing Then Return
        Dim EmailAddress = BSEmailAdresse.At(Of DtsDaten.EmailAdresseRow)
        If ShowMessageBoxAndAskUserYesOrNo($"Die Emailadresse {EmailAddress.Adresse} wird gelöscht.
                Sind sie sicher?") Then BSEmailAdresse.RemoveCurrent()
    End Sub
    Private Sub CreateNewSupplier()
        BSLieferant.EditNew(Of dlgLieferantBearbeiten)
    End Sub
    Private Sub EditSupplier()
        If BSLieferant.Current Is Nothing Then Return
        BSLieferant.EditCurrent(Of dlgLieferantBearbeiten)
    End Sub
    Private Sub DeleteSupplier()
        If BSLieferant.Current Is Nothing Then Return
        Dim Supplier = BSLieferant.At(Of DtsDaten.LieferantRow)
        If ShowMessageBoxAndAskUserYesOrNo($"Der Lieferant {Supplier.Name} wird gelöscht.
                Sind sie sicher?") Then BSLieferant.RemoveCurrent()
    End Sub
End Class
