﻿Public Class UCKundenbestellung
    Public Property _BSFilteredBySupplierIsActivated As Boolean = False

    Private _SaveDGVColumnWidths As Boolean
    Private Const _ColumnThatContainsPhoneNumber As Integer = 10
    Private Const _ColumnThatContainsOrderDate As Integer = 1
    Private Const _ColumnThatContainsCallingDate As Integer = 2

    Public Async Sub SetSupplierToShow(BSCurrent As Object)
        For i = 0 To BSLieferant.Count - 1
            If DirectCast(BSLieferant.Item(i), Data.DataRowView).Row.Equals(DirectCast(BSCurrent, Data.DataRowView).Row) Then
                _BSFilteredBySupplierIsActivated = True
                SetBindingSource()
                Await Task.Delay(1)
                BSLieferant.Position = i
                Exit For
            End If
        Next
    End Sub
    Private Sub DGVKundenbestellung_LostFocus(sender As Object, e As EventArgs) Handles DGVKundenbestellung.LostFocus
        _SaveDGVColumnWidths = False
    End Sub
    Private Sub DGVKundenbestellung_ColumnWidthChanged(sender As Object, e As DataGridViewColumnEventArgs) Handles DGVKundenbestellung.ColumnWidthChanged
        If _SaveDGVColumnWidths Then My.Settings.DGVKundenbestellungenBreite = GetDGVColumnWidthsAsSaveableString(DGVKundenbestellung)
    End Sub
    Private Sub DGVKundenbestellung_Click(sender As Object, e As EventArgs) Handles DGVKundenbestellung.Click
        _SaveDGVColumnWidths = True
    End Sub
    Private Sub BTN_Click(sender As Object, e As EventArgs) Handles BTNKundenBstNeu.Click, BTNKundenBstKopieren.Click, BTNKundenBstBearbeiten.Click,
            BTNKundenBstLoeschen.Click, BTNSucheLoeschen.Click, BTNClearCCB.Click
        Select Case True
            Case sender Is BTNKundenBstNeu : CreateNewCustomerOrder()
            Case sender Is BTNKundenBstKopieren : CopyCustomerOrder()
            Case sender Is BTNKundenBstBearbeiten : EditCustomerOrder()
            Case sender Is BTNKundenBstLoeschen : DeleteCustomerOrder()
            Case sender Is BTNSucheLoeschen : ClearCustomerOrderSearch()
            Case sender Is BTNClearCCB : ClearClearableComboBox()
        End Select
        DGVKundenbestellung.Focus()
    End Sub
    Private Sub DGVKundenbestellung_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles DGVKundenbestellung.CellDoubleClick
        Dim SelectedOrder = BSKundenbestellung.At(Of DtsDaten.KundenbestellungRow)
        Dim DoubleClickedColumnIndex = e.ColumnIndex

        Select Case DoubleClickedColumnIndex
            Case = _ColumnThatContainsPhoneNumber
                If SelectedOrder.Telefon1.IsNotEmpty Then ShowMessageBox(SelectedOrder.Telefon1)
            Case = _ColumnThatContainsOrderDate
                SelectedOrder.DatumBestellt = System.DateTime.Now
            Case = _ColumnThatContainsCallingDate
                SelectedOrder.DatumAngerufen = System.DateTime.Now
            Case Else
                EditCustomerOrder()
        End Select
    End Sub
    Private Sub TBKundenBstDurchsuchen_TextChanged(sender As Object, e As EventArgs) Handles TBKundenBstDurchsuchen.TextChanged
        SearchCustomerOrders()
    End Sub
    Private Sub SearchCustomerOrders()
        Dim Source = GetUsedBindingsource()
        Dim Searchtext As String = TBKundenBstDurchsuchen.Text
        Source.Filter = "Kundenname Like '%" & Searchtext & "%' OR ArtNr like '%" & Searchtext & "%' OR ArtikelName like '%" & Searchtext & "%'"
    End Sub
    Private Sub CreateNewCustomerOrder()
        BSKundenbestellung.EditNew(Of dlgKundenbestellungBearbeiten)
    End Sub
    Private Sub CopyCustomerOrder()
        Dim Dts = DirectCast(BSMain.DataSource, DtsDaten)
        Dim Source = GetUsedBindingsource()
        If Source.Current Is Nothing Then Return
        Dim SelectedCustomerOrder = Source.At(Of DtsDaten.KundenbestellungRow)
        Dim tpls As New List(Of Tuple(Of DataColumn, Object))
        With Dts.Kundenbestellung
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.DatumKundenbestelltColumn, System.DateTime.Now))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.KundennameColumn, SelectedCustomerOrder.Kundenname))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.ArtNrColumn, SelectedCustomerOrder.ArtNr))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.MengeColumn, SelectedCustomerOrder.Menge))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.ArtikelNameColumn, SelectedCustomerOrder.ArtikelName))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.BestelleinheitTextColumn, SelectedCustomerOrder.BestelleinheitText))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.StueckBestellenColumn, SelectedCustomerOrder.StueckBestellen))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.Telefon1Column, SelectedCustomerOrder.Telefon1))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.Telefon2Column, SelectedCustomerOrder.Telefon2))
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.PreisColumn, SelectedCustomerOrder.Preis))
            If Not SelectedCustomerOrder.IsLieferantIDNull Then tpls.Add(Tuple.Create(Of DataColumn, Object)(.LieferantIDColumn, SelectedCustomerOrder.LieferantID))
            Source.EditNew(Of dlgKundenbestellungBearbeiten)(tpls)
        End With
    End Sub
    Private Sub EditCustomerOrder()
        Dim Source = GetUsedBindingsource()
        If Source.Current Is Nothing Then Return
        Source.EditCurrent(Of dlgKundenbestellungBearbeiten)
    End Sub
    Private Sub DeleteCustomerOrder()
        Dim Source = GetUsedBindingsource()
        If Source.Current Is Nothing Then Return
        Dim SelectedCustomerOrder = Source.At(Of DtsDaten.KundenbestellungRow)
        If ShowMessageBoxAndAskUserYesOrNo($"Die Bestellung von {SelectedCustomerOrder.Kundenname} vom {SelectedCustomerOrder.DatumKundenbestellt.ToString("dd.MM.yyyy")} wird gelöscht.
                Sind sie sicher?") Then BSKundenbestellung.RemoveCurrent()
    End Sub
    Private Sub ClearCustomerOrderSearch()
        TBKundenBstDurchsuchen.Text = ""
        BSKundenbestellung.RemoveFilter()
        BSKundenbestellungFiltered.RemoveFilter()
    End Sub
    Private Sub ClearClearableComboBox()
        CCBLieferant.Clear()
        _BSFilteredBySupplierIsActivated = Not CCBLieferant.IsEmpty
        SetBindingSource()
    End Sub
    Private Function GetUsedBindingsource() As BindingSource
        If _BSFilteredBySupplierIsActivated Then
            Return BSKundenbestellungFiltered
        Else
            Return BSKundenbestellung
        End If
    End Function
    Private Sub SetBindingSource()
        If _BSFilteredBySupplierIsActivated Then
            DGVKundenbestellung.DataSource = BSKundenbestellungFiltered
        Else
            DGVKundenbestellung.DataSource = BSKundenbestellung
        End If
    End Sub
    Protected Overrides Function ProcessCmdKey(ByRef msg As Message, ByVal keyData As Keys) As Boolean
        Select Case keyData
            Case = Keys.Control Or Keys.N : CreateNewCustomerOrder()
            Case = Keys.Control Or Keys.K : CopyCustomerOrder()
            Case = Keys.Enter : EditCustomerOrder()
            Case = Keys.Delete : If Not TBKundenBstDurchsuchen.Focused Then DeleteCustomerOrder()
            Case = Keys.Escape : ClearCustomerOrderSearch()
            Case = Keys.Back : RemoveLastCharFromSearchTextbox(TBKundenBstDurchsuchen)
            Case Else
                If TBKundenBstDurchsuchen.Focused OrElse CCBLieferant.Focused Then Return MyBase.ProcessCmdKey(msg, keyData)
                Dim PressedKeyData = IsSearchableKeyPressed(keyData)
                If PressedKeyData.SearchableKeyPressed Then
                    TBKundenBstDurchsuchen.Text &= PressedKeyData.PressedKey
                Else
                    Return MyBase.ProcessCmdKey(msg, keyData)
                End If
        End Select
    End Function

    Private Sub CCBLieferant_SelectedValueChanged(sender As Object, e As EventArgs) Handles CCBLieferant.SelectedValueChanged
        _BSFilteredBySupplierIsActivated = Not CCBLieferant.IsEmpty
        SetBindingSource()
    End Sub
End Class
