﻿Imports System.IO
Public Class frmHaupt
    Private _xmlFile As String = "Daten\Settings.xml"

    Private Sub frmHaupt_Closed(sender As Object, e As EventArgs) Handles Me.Closed
        SaveDts()
    End Sub
    Private Sub SaveDts()
        DtsDaten.WriteXml(_xmlFile)
    End Sub
    Private Sub frmHaupt_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        AddHandlersForEmailSending()
        AddHandlersForOrders()
        HideTabControlHeaders()
        SetAllDGVBindingSources()
        CreateDataFolder()
        LoadDts()
        ClearClearableComboBox()
        LoadDGVColumnwidths(UcAdressen.DGVAdresse, My.Settings.DGVAdressenSpaltenBreite)
        LoadDGVColumnwidths(UcEinstellungen.DGVEmailAdresse, My.Settings.DGVEmailAdressenSpaltenBreite)
        LoadDGVColumnwidths(UcEinstellungen.DGVLieferant, My.Settings.DGVLieferantenSpaltenBreite)
        LoadDGVColumnwidths(UcKundenbestellung.DGVKundenbestellung, My.Settings.DGVKundenbestellungenBreite)
        LoadDGVColumnwidths(UcSonderpreise.DGVSonderpreis, My.Settings.DGVSonderpreiseBreite)
        LoadDGVColumnwidths(UcLieferungen.DGVLieferungen, My.Settings.DGVLieferungenSpaltenBreite)
    End Sub
    Private Sub AddHandlersForEmailSending()
        AddHandler MailSendenKlasse.FinishedSendingMail, AddressOf HideStatusStrip
        AddHandler MailSendenKlasse.StartSendingMail, AddressOf ShowStatusStrip
    End Sub
    Private Sub ShowStatusStrip(Text As String)
        StatusStripTextLabel.Text = Text
        StatusStrip1.Visible = True
    End Sub
    Private Sub HideStatusStrip()
        StatusStripTextLabel.Text = ""
        StatusStrip1.Visible = False
    End Sub
    Private Sub AddHandlersForOrders()
        AddHandler UcLieferungen.OpenCustomerOrderFound, AddressOf ShowCustomerOrderPage
    End Sub
    Private Sub ShowCustomerOrderPage(BSCurrent As Object)
        If Not BSCurrent Is Nothing Then
            UcKundenbestellung.CCBLieferant.UndoClear()
            UcKundenbestellung.SetSupplierToShow(BSCurrent)
        End If
        TCHaupt.SelectedTab = TPKundenbestellungen
    End Sub
    Private Sub HideTabControlHeaders()
        With TCHaupt
            .SuspendLayout()
            .SizeMode = TabSizeMode.Fixed
            .ItemSize = New Size(0, 1)
            .Appearance = TabAppearance.Buttons
            .ResumeLayout()
        End With
    End Sub
    Private Sub SetAllDGVBindingSources()
        UcAdressen.BSMain.DataSource = DtsDaten
        UcEinstellungen.BSMain.DataSource = DtsDaten
        UcKundenbestellung.BSMain.DataSource = DtsDaten
        UcSonderpreise.BSMain.DataSource = DtsDaten
        UcLieferungen.BSMain.DataSource = DtsDaten
    End Sub
    Private Sub CreateDataFolder()
        Directory.CreateDirectory(My.Application.Info.DirectoryPath & "\Daten")
    End Sub
    Private Sub LoadDts()
        If File.Exists(_xmlFile) Then DtsDaten.ReadXml(_xmlFile)
    End Sub
    Private Sub ClearClearableComboBox()
        UcKundenbestellung.CCBLieferant.Clear()
    End Sub
    Private Sub MSEintrag_Click(sender As Object, e As EventArgs) Handles MSStart.Click, MSAdressen.Click, MSEinstellungen.Click,
            MSKundenbestellungen.Click, MSSonderpreise.Click, MSLieferung.Click
        Select Case True
            Case sender Is MSStart : ShowStartPage()
            Case sender Is MSAdressen : ShowAddressPage()
            Case sender Is MSEinstellungen : ShowSettingsPage()
            Case sender Is MSKundenbestellungen : ShowCustomerOrderPage(Nothing)
            Case sender Is MSSonderpreise : ShowSpecialPricesPage()
            Case sender Is MSLieferung : SelectSupplierAndShowDeliveryPage()
        End Select
    End Sub
    Private Sub ShowAddressPage()
        TCHaupt.SelectedTab = TPAdressen
    End Sub
    Private Sub ShowStartPage()
        TCHaupt.SelectedTab = TPStart
    End Sub
    Private Sub ShowSettingsPage()
        TCHaupt.SelectedTab = TPEinstellungen
    End Sub
    Private Sub ShowSpecialPricesPage()
        TCHaupt.SelectedTab = TPSonderpreis
    End Sub
    Private Sub SelectSupplierAndShowDeliveryPage()
        Dim SelectedSupplierPosition As Integer
        Using SupplierSelect As New dlgLieferantenAuswahl
            SupplierSelect.BSMain.DataSource = DtsDaten
            If SupplierSelect.ShowDialog = DialogResult.OK Then
                SelectedSupplierPosition = SupplierSelect.SupplierPosition
            Else
                Return
            End If
        End Using
        UcLieferungen.BSLieferant.Position = SelectedSupplierPosition
        TCHaupt.SelectedTab = TPLieferungen
    End Sub

End Class